> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-en/sdk/domains-api/device/device.subscribelocation.md).

# Device.subscribeLocation

> Functional API `startUpdateLocation`You can use the same function with this as well.

### Feature description

Continue detecting changes in the device's location, and whenever the location changes `onEvent` call the callback. You must unsubscribe with the returned cleanup function. `timeInterval`may be longer than the specified value due to system effects.

If you don't have location permission, `onError` to the callback `StartUpdateLocationPermissionError`(`GetCurrentLocationPermissionError`and an instance of the same class) is passed. `Device.subscribeLocation.getPermission()` / `Device.subscribeLocation.openPermissionDialog()`you can check/request permission with

### Type

```ts
Device.subscribeLocation(params: StartUpdateLocationEventParams): () => void;
```

**Params**

```ts
type StartUpdateLocationEventParams = {
  onEvent: (location: Location) => void;
  onError: (error: unknown) => void;
  options: {
    accuracy: Accuracy;
    /** Minimum location update interval (ms). */
    timeInterval: number;
    /** Distance (m) to detect location changes. */
    distanceInterval: number;
  };
};
```

**Response**

cleanup function that unsubscribes (`() => void`).

### Error

The error is `onError` is passed to the callback as a class instance — `error instanceof StartUpdateLocationPermissionError`identify it with. The class can `@apps-in-toss/web-framework`be imported from

| Error class                          | Description                                                                                                            |
| ------------------------------------ | ---------------------------------------------------------------------------------------------------------------------- |
| `StartUpdateLocationPermissionError` | when location update permission is denied. `Device.subscribeLocation.openPermissionDialog()`You can request again with |

### Example code

```js
import {
  Accuracy,
  Device,
  StartUpdateLocationPermissionError,
} from "@apps-in-toss/web-framework";

const cleanup = Device.subscribeLocation({
  options: {
    accuracy: Accuracy.Balanced,
    timeInterval: 3000,
    distanceInterval: 10,
  },
  onEvent: (location) => {
    console.log(location.coords.latitude, location.coords.longitude);
  },
  onError: (error) => {
    if (error instanceof StartUpdateLocationPermissionError) {
      console.warn("No location permission.");
      return;
    }
    console.error(error);
  },
});

// Unsubscribe
cleanup();
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-en/sdk/domains-api/device/device.subscribelocation.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
